#pragma once

#include <Array.h>
#include <Vec2.h>
#include "SSKlientV.h"

class Spieler;
class SpielerStatistik;
class TeamStatistik;

class Klient
{
private:
    SSKlientV *klient;
    int ref;

public:
    // Konstruktor
    Klient( SSKlientV *klient );
    // Destruktor
    ~Klient();
    // nicht constant
    void offline();
    void online( SSKlientV *zKlient );
    void sendeInit( RCArray< Spieler > *zSpieler, int spielZeit );
    void sendeSpielerNummer( int sNum, int spielZeit );
    void sendeStart( int spielZeit );
    void sendeTastaturStatus( int spielerId, char taste, bool aktiv, int spielZeit );
    void sendeSpielEnde( char gewonnen, int spielZeit );
    void sendeChatNachricht( char *txt, int spielZeit );
    void sendeStatistikChatNachricht( int vonAccount, char *txt );
    void sendeStatistikSpielerOffline( int account );
    void sendeSpielerStatistik( SpielerStatistik *zS );
    void sendeTeamStatistik( TeamStatistik *zS );
    void sendeStatistikLadenFertig();
    // constant
    bool istOnline() const;
    // reference Counting
    Klient *getThis();
    Klient *release();
};